
/* this file is a part of gau software, (C) Hwang chi-deok 1997, 1998         */

#include <string.h> /* strncpy */
#include <gtk/gtk.h>
#include "config.h"
#include "chartable.h"
#include "gau.h"
#include "gauchat.h"
#include "scrolledchat.h"


extern GauScrolledChat *schat;
static void
 char_frame(GtkWidget * notebook, char *title,
	    char first, char second, int row, int col,
   void (*func) (GtkWidget * w, char *buf, GtkWidget * entry), gpointer);
static void toentry(GtkWidget * table, char *buf, GtkWidget * entry);
static void entry_set_bg(GtkWidget * entry);
static void entry_clear(GtkWidget * button, GtkWidget * entry);
static void char_table_destroy(CharTable * table);
void from_si(GtkWidget * button, GtkWidget * entry);

void special_char_input(void (*func) (GtkWidget * w, GtkWidget * entry))
{
    GtkWidget *notebook;
    static GtkWidget *win = NULL;
    GtkWidget *entry, *button, *vbox, *hbox;
    GtkWidget *separator;
    if (win) {
	gtk_widget_show(win);
	return;
    }
    win = gtk_window_new(GTK_WINDOW_DIALOG);
    gtk_window_position(GTK_WINDOW(win), GTK_WIN_POS_CENTER);
    gtk_signal_connect(GTK_OBJECT(win), "destroy",
		       GTK_SIGNAL_FUNC(gtk_widget_destroyed), &win);
    gtk_window_set_title(GTK_WINDOW(win), ": Ư Է");
    gtk_container_border_width(GTK_CONTAINER(win), 10);
    vbox = gtk_vbox_new(FALSE, 5);
    gtk_container_add(GTK_CONTAINER(win), vbox);
    gtk_widget_show(vbox);

    notebook = gtk_notebook_new();
    gtk_notebook_set_tab_pos(GTK_NOTEBOOK(notebook), GTK_POS_TOP);
    gtk_box_pack_start(GTK_BOX(vbox), notebook, TRUE, TRUE, 0);
    gtk_widget_show(notebook);

    separator = gtk_hseparator_new();
    gtk_box_pack_start(GTK_BOX(vbox), separator, FALSE, FALSE, 0);
    gtk_widget_show(separator);


    hbox = gtk_hbox_new(FALSE, 5);
    gtk_box_pack_end(GTK_BOX(vbox), hbox, FALSE, FALSE, 0);
    gtk_widget_show(hbox);
    entry = gtk_entry_new();
    gtk_box_pack_start(GTK_BOX(hbox), entry, TRUE, TRUE, 0);
    gtk_widget_show(entry);
    gtk_signal_connect(GTK_OBJECT(entry), "realize",
		       GTK_SIGNAL_FUNC(entry_set_bg), NULL);

    button = gtk_button_new_with_label("");
    GTK_WIDGET_UNSET_FLAGS(button, GTK_CAN_FOCUS);
    gtk_box_pack_end(GTK_BOX(hbox), button, FALSE, FALSE, 0);
    gtk_signal_connect(GTK_OBJECT(button), "clicked",
		       GTK_SIGNAL_FUNC(func), entry);
    gtk_widget_show(button);

    button = gtk_button_new_with_label("ݱ");
    GTK_WIDGET_UNSET_FLAGS(button, GTK_CAN_FOCUS);
    gtk_box_pack_end(GTK_BOX(hbox), button, FALSE, FALSE, 0);
    gtk_signal_connect_object(GTK_OBJECT(button), "clicked",
		      GTK_SIGNAL_FUNC(gtk_widget_hide), GTK_OBJECT(win));
    gtk_widget_show(button);

    button = gtk_button_new_with_label("");
    GTK_WIDGET_UNSET_FLAGS(button, GTK_CAN_FOCUS);
    gtk_box_pack_end(GTK_BOX(hbox), button, FALSE, FALSE, 0);
    gtk_signal_connect(GTK_OBJECT(button), "clicked",
		       GTK_SIGNAL_FUNC(entry_clear), entry);
    gtk_widget_show(button);

    char_frame(notebook, "׸1", 0xa1, 0xa0, 6, 16, toentry, entry);
    char_frame(notebook, "׸2", 0xa2, 0xa0, 6, 12, toentry, entry);
    char_frame(notebook, "", 0xa3, 0xa0, 6, 16, toentry, entry);
    char_frame(notebook, "ѱڸ", 0xa4, 0xa0, 6, 16, toentry, entry);
    char_frame(notebook, "", 0xa6, 0xa0, 5, 14, toentry, entry);
    char_frame(notebook, "", 0xa7, 0xa0, 5, 16, toentry, entry);
    char_frame(notebook, "", 0xa8, 0xa0, 6, 16, toentry, entry);
    char_frame(notebook, "ȣ", 0xa9, 0xa0, 6, 16, toentry, entry);
    gtk_widget_show(win);
}

static void entry_set_bg(GtkWidget * entry)
{
    gdk_window_set_background(entry->window,
			      &entry->style->bg[GTK_STATE_NORMAL]);
    gdk_window_set_background(GTK_ENTRY(entry)->text_area,
			      &entry->style->bg[GTK_STATE_NORMAL]);
}

void from_si(GtkWidget * button, GtkWidget * entry)
{
    char *buf = gtk_entry_get_text(GTK_ENTRY(entry));
    if (chat_win == NULL || !GTK_WIDGET_VISIBLE(chat_win)) {
	term->from_term(buf, strlen(buf));
    } else {
	gau_chat_insert_text(schat->chat, buf, strlen(buf));
    }
}

static void entry_clear(GtkWidget * button, GtkWidget * entry)
{
    gtk_entry_set_text(GTK_ENTRY(entry), "");
}

void si_cb(GtkWidget * w, gpointer foo)
{
    special_char_input(from_si);
}

static void char_frame(GtkWidget * notebook, char *title,
		       char first, char second, int row, int col,
		       void (*select_func) (GtkWidget * w, char *buf, GtkWidget * entry), gpointer data)
{
    GtkWidget *frame, *label;
    GtkWidget *table;
    int i, j, k;
    char **buf;

    buf = g_new(char *, col);
    for (i = 0; i < col; i++)
	buf[i] = g_new(char, row * 2);
    k = second;
    for (i = 0; i < col; i++)
	for (j = 0; j < row; j++) {
	    buf[i][2 * j] = first;
	    buf[i][2 * j + 1] = k++;
	}

    frame = gtk_frame_new(NULL);
    gtk_container_border_width(GTK_CONTAINER(frame), 10);
    gtk_widget_show(frame);

    table = char_table_new(buf, col, row);
    gtk_container_add(GTK_CONTAINER(frame), table);
    gtk_signal_connect(GTK_OBJECT(table), "destroy",
		       GTK_SIGNAL_FUNC(char_table_destroy), NULL);
    gtk_signal_connect(GTK_OBJECT(table), "selected",
		       GTK_SIGNAL_FUNC(select_func), data);
    gtk_widget_show(table);
    label = gtk_label_new(title);
    gtk_notebook_append_page(GTK_NOTEBOOK(notebook), frame, label);
}

/* insert text from chartable to entry buffer
   text is two byte i.e. one hangul code
 */
static void toentry(GtkWidget * chartable, char *buf, GtkWidget * w)
{
    int pos, len;
    char *nbuf, *obuf;
    GtkEntry *entry;

    entry = GTK_ENTRY(w);
    obuf = gtk_entry_get_text(entry);
    len = strlen(obuf) + 2;
    nbuf = g_new(char, len + 1);
    pos = ((GtkEditable *) entry)->current_pos;
    strncpy (nbuf, obuf, pos);
    strncpy (nbuf + pos, buf, 2);
    strcpy (nbuf + pos + 2, obuf + pos);
    gtk_entry_set_text(entry, nbuf);
    gtk_entry_set_position(entry, pos + 2);
    g_free(nbuf);
    gtk_widget_draw(GTK_WIDGET(entry), NULL);
}

static void char_table_destroy(CharTable * table)
{
    int i;
    for (i = 0; i < table->col; i++) {
	g_free(table->buf[i]);
    }
    g_free(table->buf);
}
