/* this file is a part of gau software, (C) Hwang chi-deok 1997, 1998         */

#include "config.h"

#include <glib.h>
#include <sys/types.h>
#include <signal.h>

#ifdef HAVE_SYS_WAIT_H
# include <sys/wait.h>
#endif

typedef struct {
	pid_t pid;
	void (*func)(void);
} Signal;

GList *s_list = NULL;

void
child_signal_add(pid_t pid, void (*func)(void))
{
	Signal *s_handler = g_new(Signal, 1);
	s_handler->pid = pid;
	s_handler->func = func;
	s_list = g_list_append(s_list, s_handler);
}

void
child_signal_handler(int signum)
{
	GList *list = s_list;
	Signal *s_handler;
	pid_t pid = wait(NULL);
	while(list) {
		s_handler = list->data;
		if(pid == s_handler->pid) {
			(*s_handler->func)();
			s_list = g_list_remove(s_list, s_handler);
			g_free(s_handler);
			break;
		}
		list = list->next;
	}
	signal(SIGCHLD, child_signal_handler);
}

