
/* this file is a part of gau software, (C) Hwang chi-deok 1997, 1998         */

#include <gtk/gtk.h>
#include <stdarg.h>
#include <gdk/hangulinput.h>
#include "gau.h"

extern void hangul_input_toggle(gpointer foo);
extern char *g_vsprintf (const gchar *fmt, va_list *args, va_list *args2);
GtkWidget *status_label;
GtkWidget *time_label;
GtkWidget *han_input_label;
GtkWidget *keyboard_label;

void han_input_state_show(void)
{
    if (hangul_input_state_get())
	gtk_label_set(GTK_LABEL(han_input_label), " ѱ ");
    else
	gtk_label_set(GTK_LABEL(han_input_label), "  ");
}

void keyboard_button_click(GtkWidget * w)
{
    if (hangul_keyboard_get() == 2) {
	hangul_keyboard_set(3);
	gtk_label_set(GTK_LABEL(keyboard_label), "");
    } else {
	hangul_keyboard_set(2);
	gtk_label_set(GTK_LABEL(keyboard_label), "ι");
    }
}

void status_bar(GtkWidget * box)
{
    GtkWidget *frame;
    GtkWidget *hbox, *button;

    hangul_input_state_changed_callback = han_input_state_show;

    status_label = gtk_label_new("");
    gtk_box_pack_start(GTK_BOX(box), status_label, FALSE, FALSE, 2);
    gtk_misc_set_alignment(GTK_MISC(status_label), 0.0, 0.5);

    // time
    frame = gtk_frame_new(NULL);
    gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_ETCHED_IN);
    gtk_box_pack_end(GTK_BOX(box), frame, FALSE, FALSE, 5);
    time_label = gtk_label_new(" 00:00 ");
    gtk_widget_set_name(time_label, "time-label");
    gtk_container_add(GTK_CONTAINER(frame), time_label);

    // han input state
    frame = gtk_frame_new(NULL);
    gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_ETCHED_IN);
    gtk_box_pack_end(GTK_BOX(box), frame, FALSE, FALSE, 5);

    hbox = gtk_hbox_new(FALSE, 2);
    gtk_container_add(GTK_CONTAINER(frame), hbox);

    button = gtk_button_new();
    GTK_WIDGET_UNSET_FLAGS(button, GTK_CAN_FOCUS);
    gtk_box_pack_start(GTK_BOX(hbox), button, FALSE, FALSE, 2);
    han_input_label = gtk_label_new("  ");
    gtk_container_add(GTK_CONTAINER(button), han_input_label);
    han_input_state_show();
    gtk_signal_connect(GTK_OBJECT(button), "clicked",
		       GTK_SIGNAL_FUNC(hangul_input_toggle), NULL);

    button = gtk_button_new();
    GTK_WIDGET_UNSET_FLAGS(button, GTK_CAN_FOCUS);

    gtk_box_pack_start(GTK_BOX(hbox), button, FALSE, FALSE, 2);
    if (hangul_keyboard_get() == 2)
	keyboard_label = gtk_label_new("ι");
    else
	keyboard_label = gtk_label_new("");
    gtk_container_add(GTK_CONTAINER(button), keyboard_label);
    gtk_signal_connect(GTK_OBJECT(button), "clicked",
		       GTK_SIGNAL_FUNC(keyboard_button_click), NULL);

    // in & out status report
#if 0
    in_pixmap[0] =;
    in_pixmap[1] =;
    out_pixmap[0] =;
    out_pixmap[1] =;
#endif
}

void append_message(char *buf)
{
    gchar *orig;
    gtk_label_get(GTK_LABEL(status_label), &orig);
    show_message ("%s %s", orig, buf);
}

void show_message(const gchar *format, ...)
{
    va_list args, args2;
    char *buf;

    va_start (args, format);
    va_start (args2, format);
    buf = g_vsprintf (format, &args, &args2);
    va_end (args);
    va_end (args2);
    gtk_label_set (GTK_LABEL (status_label), buf);
}

void show_time(int second)
{
    char buf[10];
    g_snprintf(buf, 10, " %02d:%02d ", second / 60, second % 60);
    gtk_label_set(GTK_LABEL(time_label), buf);
}

void show_incoming(gboolean flag)
{
}

void show_outgoing(gboolean flag)
{
}
